EDBFrame = CreateFrame("Frame", "EDBFrame")

local playername=(UnitName("PLAYER"));

EDB = {};
function EDBEvent(self, event, ...)
	if (event=="ADDON_LOADED") then
		local addon = ...;
		if (addon=="Blizzard_GuildUI") then
			EDB_CreateFrame();
			GuildRosterContainer:HookScript("OnUpdate", function() EDB_GuildFrameUpdated() end);
			EDBFrame:UnregisterEvent("ADDON_LOADED");
		end
	end
end

EDBFrame:SetScript("OnEvent", EDBEvent);
EDBFrame:RegisterEvent("ADDON_LOADED");
EDBFrame:RegisterEvent("CHAT_MSG_ADDON");

function Elgoh_ResizeGuildFrame()
	GuildMemberDetailFrame:SetHeight(GuildMemberDetailFrame:GetHeight()+25);
end

function EDB_CreateFrame()
	if (GuildMemberDetailFrame) then		
		EDBDKPText = GuildMemberDetailFrame:CreateFontString("EDBDKPText", "ARTWORK", "GameFontNormal");
		EDBDKPText:SetHeight(10);
		EDBDKPText:SetJustifyH("LEFT");
		EDBDKPText:SetPoint("TOPLEFT", GuildMemberNoteBackground, "BOTTOMLEFT", 5, -5);
		
		EDBThreshText = GuildMemberDetailFrame:CreateFontString("EDBThreshText", "ARTWORK", "GameFontNormal");
		EDBThreshText:SetHeight(10);
		EDBThreshText:SetJustifyH("RIGHT");
		EDBThreshText:SetPoint("TOPRIGHT", GuildMemberNoteBackground, "BOTTOMRIGHT", -5, -5);
		
		GuildMemberDetailOfficerNoteLabel:ClearAllPoints();
		GuildMemberDetailOfficerNoteLabel:SetPoint("TOPLEFT", EDBDKPText, "BOTTOMLEFT", -5, -10);
		
		hooksecurefunc("GuildRoster_Update", Elgoh_ResizeGuildFrame);
		
		if(CanEditOfficerNote()==1) then
			EDBEPGPFrame = CreateFrame("Frame", "EDBEPGPFrame")
			EDBEPGPFrame:SetParent(GuildMemberDetailFrame);
			EDBEPGPFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
			EDBEPGPFrame:SetHeight(85);
			EDBEPGPFrame:SetPoint("TOPLEFT", EDBFrame, "BOTTOMLEFT", 0, 5);
			EDBEPGPFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
			
			EDBAwardGP = CreateFrame("Button", EDBAwardGP, EDBEPGPFrame, "UIPanelButtonTemplate");
			EDBAwardGP:SetWidth(40);
			EDBAwardGP:SetHeight(40);
			EDBAwardGP:SetText("GP");
			EDBAwardGP:SetPoint("RIGHT", EDBEPGPFrame, "RIGHT", -15,15);
			EDBAwardGP:SetScript("OnClick", function() EDB_GrantEPGP("GP", tonumber(EDBAmountBox:GetText()), EDB.selected, false); end)
			
			EDBAwardEP = CreateFrame("Button", EDBAwardEP, EDBEPGPFrame, "UIPanelButtonTemplate");
			EDBAwardEP:SetWidth(40);
			EDBAwardEP:SetHeight(40);
			EDBAwardEP:SetText("EP");
			EDBAwardEP:SetPoint("RIGHT", EDBAwardGP, "LEFT", -5,0);
			EDBAwardEP:SetScript("OnClick", function() EDB_GrantEPGP("EP", tonumber(EDBAmountBox:GetText()), EDB.selected, false); end);
			
			EDBAmountBox = CreateFrame("EditBox", nil, EDBEPGPFrame, "InputBoxTemplate")
			--EDBAmountBox:SetWidth(60)
			EDBAmountBox:SetHeight(20)
			EDBAmountBox:SetPoint("LEFT", EDBEPGPFrame, "LEFT", 15,0);
			EDBAmountBox:SetPoint("RIGHT", EDBAwardEP, "LEFT", -5,0);
			EDBAmountBox:SetAutoFocus(false)
			EDBAmountBox:SetJustifyH("LEFT");
			EDBAmountBox:SetText("0");
			EDBAmountBox:SetScript("OnEnterPressed", function() EDBAmountBox:ClearFocus(); end)
			
			EDBReasonBox = CreateFrame("EditBox", nil, EDBEPGPFrame, "InputBoxTemplate")
			EDBReasonBox:SetHeight(20)
			EDBReasonBox:SetPoint("LEFT", EDBEPGPFrame, "LEFT", 15,0);
			EDBReasonBox:SetPoint("RIGHT", EDBEPGPFrame, "RIGHT", -15,0);
			EDBReasonBox:SetPoint("TOP", EDBAwardEP, "BOTTOM", 0,10);
			EDBReasonBox:SetAutoFocus(false)
			EDBReasonBox:SetJustifyH("LEFT");
			EDBReasonBox:SetText("0");
			EDBReasonBox:SetScript("OnEnterPressed", function() EDBReasonBox:ClearFocus(); end)
		end
	end
end

function EDB_GuildFrameUpdated()
	local pname= GetGuildRosterInfo(GetGuildRosterSelection());
	if pname then
		if(pname == EDB.selected) then return end
		EDB.selected = pname;
		EDB_Snapshot(UnitName("PLAYER"));
		EDB_Snapshot(pname);
		EDB_UpdateLines(EDB.selected);
	end
end

function EDB_UpdateLines(who)
	EDBDKPText:SetText("");
	local EPGPThreshhold=ElgohSettings["EPGPThreshhold"];
	if(EDB[who]) then
		if(who~=playername) then
			if(EDB[playername] and EDB[playername]["priority"]~=nil) then
				if(EDB[who]["priority"]) then
					EDBDKPText:SetText("EP/GP: "..EDB[who]["priority"]);
					EDBDKPText:SetTextColor(0.2,1,0.2);
					if((EDB[playername]["earned"]>EPGPThreshhold and EDB[who]["earned"]>EPGPThreshhold) or (EDB[playername]["earned"]<EPGPThreshhold and EDB[who]["earned"]<EPGPThreshhold)) then
						if(EDB[who]["priority"]>EDB[playername]["priority"]) then
							EDBDKPText:SetTextColor(1,0.2,0.2);
						end
					elseif(EDB[playername]["earned"]<EPGPThreshhold and EDB[who]["earned"]>EPGPThreshhold) then
						EDBDKPText:SetTextColor(1,0.2,0.2);
					end
				end
			end
		else
			EDBDKPText:SetText("EP/GP: "..EDB[playername]["priority"]);
			EDBDKPText:SetTextColor(1,1,1);			
		end
		if(EDB[who]["earned"]>EPGPThreshhold) then EDBThreshText:SetTextColor(0.2,1,0.2); EDBThreshText:SetText("Above "..EPGPThreshhold); else EDBThreshText:SetTextColor(1,0.2,0.2); EDBThreshText:SetText("Below "..EPGPThreshhold); end
	end
end

function EDB_LoadValues(who)
	EDB[who]={};
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);
		if(who==nil or name==who) then
			if(GL_DKPValues["current_dkp_data"][name:lower()]~=nil) then
				EDB[name].earned=GL_DKPValues["current_dkp_data"][name:lower()]["earned"];
				EDB[name].spent=GL_DKPValues["current_dkp_data"][name:lower()]["spent"];
				EDB[name].priority=GL_DKPValues["current_dkp_data"][name:lower()]["current"];
			else
				EDB[name].earned=0;
				EDB[name].spent=0;
				EDB[name].priority=0;
			end
			EDB_ToNote(name);
		end
	end
end

function EDB_ToNote(who)
	if(CanEditOfficerNote()~=1) then Elgoh_Print("I can't let you do that, "..playername); return; end
	if(ElgohSettings.officernote~=1) then return; end
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);	
		if(who==nil or name==who) then
		if(EDB[who].earned~=0) then
			if(EDB[who].spent~=0) then
				EDB[who].priority=(floor(((EDB[who].earned/EDB[who].spent)*100) + 0.5 )) /100;
			else
				EDB[who].priority=EDB[who].earned;
			end
		end
		local oNote=strjoin(":","$"..EDB[name]["earned"], EDB[name]["spent"], EDB[name]["priority"].."$");
		GuildRosterSetOfficerNote(i, oNote);
		end
	end
end

function EDB_Snapshot(who)
if(CanEditOfficerNote()~=1) then EDebug("Querying Officers..."); QueryOfficer(name); return; end
	for i = 1, GetNumGuildMembers(), 1 do
		local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
		if(name==who) then
			local EDBString=string.match(officernote, "$(.*)%$");
			if(EDBString==nil) then Elgoh_Print("No DKP String found: Restoring "..name); EDB_LoadValues(name); return; end
			
			local Earned,Spent,Priority=strsplit(":",EDBString);
			Earned=tonumber(Earned);
			Spent=tonumber(Spent);
			Priority=tonumber(Priority);
			
			if(Earned==nil or Spent==nil or Priority==nil) then Elgoh_Print("Invalid EPGP string found: Reloading "..name); EDB_LoadValues(name); return; end
			
			if(Priority~=(floor(((Earned/Spent)*100) + 0.5 ))/100 and Priority~=0 and Priority~=Earned) then 
				Elgoh_Print("Edited EPGP string found (values have been altered): Reloading "..name); 
				EDB_LoadValues(name); 
				SendChatMessage("Warning: EPGP for "..name.." had been edited", "OFFICER");
				return; 
			end
			
			EDB[name]={};
			EDB[name]["earned"]=Earned;
			EDB[name]["spent"]=Spent;
			EDB[name]["priority"]=Priority;
			return;
		end
	end
end

function QueryOfficer(who)
	ElgohWaitingOnOfficer=true;
	EDBFrame:SetScript("OnUpdate", EDBFrame_OnUpdate);
	EDBFrame.TimeSinceLastUpdate=0;
	SendAddonMessage("elgoh", "!"..who, "GUILD");
end

function EDBFrame_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed; 	

	if(self.TimeSinceLastUpdate>=0.5) then
		if(ElgohWaitingOnOfficer==true) then
			EDBSpecText:SetText("No Officer Replies");
		--	Elgoh_Print("No Officer reply");
		end
		self.TimeSinceLastUpdate = 0;
		ElgohWaitingOnOfficer=false;
		self:SetScript("OnUpdate", nil);
	end
end

function EDB_GrantEPGP(EPGP, amount, who, mass, reason)
	if(EPGP=="EP") then values="earned"; else values="spent"; end
	if mass then
		for i=1,#who do
			EDB_Snapshot(who[i]);
			EDB[who[i]][values]=EDB[who[i]][values]+amount;
			EDB_ToNote(who[i]);
		end
		local msg=#who.." peoples "..EPGP.." has been changed by "..amount;
		if(reason~=nil) then msg=msg.." for "..reason; end
		SendChatMessage(msg, "OFFICER");
	else
		EDB_Snapshot(who);
		EDB[who][values]=EDB[who][values]+amount;
		EDB_ToNote(who);
		local msg=who.."'s "..EPGP.." has been changed by "..amount;
		if(reason~=nil) then msg=msg.." for "..reason; end
		SendChatMessage(msg, "OFFICER");
		if(EDBDKPText~=nil) then EDB_UpdateLines(EDB.selected); end
	end
end